<?php

/**
 * SimpleXMLExtended Class
 *
 * Extends the default PHP SimpleXMLElement class by 
 * allowing the addition of cdata
 *
 * @since 1.0
 *
 * @param string $cdata_text
 */


class SimpleXMLExtended extends SimpleXMLElement{   
  public function addCData($cdata_text){   
   $node= dom_import_simplexml($this);   
   $no = $node->ownerDocument;   
   $node->appendChild($no->createCDATASection($cdata_text));   
  } 
} 



/**
 * Get XML Data
 *
 * Turns the XML file into an object 
 *
 * @since 1.0
 *
 * @param string $file
 * @return object
 */
function getXML($file) {
	$xml = file_get_contents($file);
	$data = simplexml_load_string($xml, 'SimpleXMLExtended', LIBXML_NOCDATA);
	return $data;
}

/**
 * XML Save
 *
 * @since 2.0
 * @todo create and chmod file before ->asXML call (if it doesnt exist already, if so, then just chmod it.)
 *
 * @param object $xml
 * @param string $file Filename that it will be saved as
 * @return bool
 */
function XMLsave($xml, $file) {
	$success = $xml->asXML($file) === TRUE;
}

/**
 * Clean URL
 *
 * @since 1.0
 *
 * @param string $text
 * @return string
 */
function clean_url($text)  { 
	$text = strip_tags(strtolower($text)); 
	$code_entities_match = array(' ?',' ','--','&quot;','!','@','#','$','%','^','&','*','(',')','+','{','}','|',':','"','<','>','?','[',']','\\',';',"'",',','/','*','+','~','`','=','.'); 
	$code_entities_replace = array('','-','-','','','','','','','','','','','','','','','','','','','','','','','',''); 
	$text = str_replace($code_entities_match, $code_entities_replace, $text); 
	$text = urlencode($text);
	$text = str_replace('--','-',$text);
	$text = rtrim($text, "-");
	return $text; 
} 



//-----------------------------------------------------------------//
//-----------------------------------------------------------------//
//-----------------------------------------------------------------//

  $err='';
  session_start();
  $imagenCadena = $_SESSION["imagencadena"]; 
  $pot = trim(strtolower($imagenCadena));
  $server_name = getenv ("SERVER_NAME");       // Server Name
  $request_uri = getenv ("REQUEST_URI");       // Requested URI
  $miarr = '';
  global $i18n;
   //call lang: array i18n
   if (is_file('lang/'.$LANG.'.php')){
	 include ('lang/'.$LANG.'.php');
   } else {
	 include ('lang/en_US.php');
   }

  //check Token  
  if (isset($_POST['guest-submit'])) {
      $MIURL= $_POST['guest']['q_uri'];
      $posmiar= strpos($MIURL, 'miarr=');
      if ($posmiar){
	      $MIURL = substr($MIURL,0, $posmiar - 1);	 
 	      $_POST['guest']['q_uri'] = $MIURL;
      }       
  
      if ($_POST['guest']["q_token".$_POST['guest']['q_count']]  != $_SESSION["pc_Token".$_POST['guest']['q_count']]){
            //if don't come from form
            $_GET['tp'] = 'noenter';
            $seg= 4;
	    $msgshw = '<div id="msgerr">*** '.strtoupper($i18n['MSG_pcERR']).' ***</div><br />';
     
     }
  }


//-----------------------------------------------------
//             SAVE DATA OF FORM IN LOG
//-----------------------------------------------------
  if (@$_GET['tp'] == 'guest') {
	if (isset($_POST['guest-submit'])) {
		 $id = @$_GET['idf'] ;
                 $answ = @$_GET['ans'] ;
	         $log_file= $_POST['guest']['q_file'];
                 $posstr= strrpos($log_file, "/"); 
                 $log_file_red= substr($log_file, $posstr+1);    
                 $log_path = substr($log_file,0, $posstr);
                 $EMAIL = $_POST['guest']['q_email'];
		 $MICOUNT= $_POST['guest']['q_count'] - 1;
		 $LANG= $_POST['guest']['q_lang'];
		 $capt= $_POST['guest']['q_capt'];
		 $moder= $_POST['guest']['q_moder'];
		 $sendphpmail= $_POST['guest']['q_phpmailer'];
		 if ($moder == 'Y') {
			$moder = 'N';
		 } else {
			$moder = 'Y';
		 }

 		 if ($capt =='Y'){
	                 if ( $pot == trim(strtolower($_POST['guest']['pot']))) {
	        	      $captcha = strtolower($_POST['guest']['pot']);                
	        	 }
		         else {
	 		 	$err = $i18n['MSG_CAPTCHA_FAILED'];
			 }

		 }
		
                 $from ='';
		 if ( $_POST['guest']['email'] != '' ) {
			if ($_POST['guest']['email'] != $i18n['em_text']){
				$from = $_POST['guest']['email'];
			} else {
				$_POST['guest']['email'] = '';
			}

		 }

		$temp = $_POST['guest'];
		$temp['comentario'] = $_POST['comentario'];

         	if ($err == '' && trim($_POST['guest']['nombre']) !='' && trim($_POST['comentario']) !='') {

			$server_name = getenv ("SERVER_NAME");       // Server Name
			$request_uri = getenv ("REQUEST_URI");       // Requested URI

			$headers = "From: ".$from."\r\n";
			$headers .= "Return-Path: ".$from."\r\n";
			$headers .= "Content-type: text/html; charset=UTF-8 \r\n";

			unset($temp['pot']);
			unset($temp['guest-submit']);
			unset($temp['submit']);
                        
			$body = '';
			$body .= $i18n['pc_FORM_SUB'].' '.$i18n['WHO'].' Page: '.$log_file.' <br />';
			$body .= "-----------------------------------<br /><br />";


			if ( ! file_exists($log_file) ) {
               			$xml = new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><channel></channel>');
                                $count = 0;
				$sid = 0;
			} else
			{
				$xmldata = file_get_contents($log_file);
		       		$xml = new SimpleXMLExtended($xmldata);
			        //search SubId with xpath
	   		        $domDocument = new DomDocument();
		                $domDocument->load($log_file);
			        $xpath = new DOMXPath($domDocument);
                                //search id when is a new comment
                                if ($answ == 'n'){
			            $verNode = $xpath->query("entry/Id[../answ='n']");
				    $L_vn= $verNode->length;
				    if ($L_vn == 0){
					$id = 0;
				    } else {
					$id = ($verNode->item($L_vn -1)->nodeValue) + 1;
				    }
                                 }
			        //filter by value of nodo entry/Id= $id
			        //to know value of SubId and add 1 if is necesary.
                                if ($answ != 'n'){
				        $verNode = $xpath->query("entry/SubId[../Id=$id]");
					$L_vn= $verNode->length;
					if ($L_vn == 0){
						$sid = 0;
					} else {
						$sid = ($verNode->item($L_vn -1)->nodeValue) + 1;
					}
                                } else {
					$sid = 0;   
                                } 
                        }

                        //save data
				$thislog = $xml->addChild('entry');
                                $thislog->addAttribute('id', $id);
				$cdata = $thislog->addChild('Id');
				       $cdata->addCData($id);				
				$cdata = $thislog->addChild('SubId');
				       $cdata->addCData($sid);   
 				$cdata = $thislog->addChild('Nb');	
				       $cdata->addCData(html_entity_decode($temp['nombre']));
                                $dater = date('r');
                                $dateseg = strftime('%s', strtotime($dater));
				$thislog->addChild('date', $dater);
				$thislog->addChild('dateseg', $dateseg);
        	                $cdata = $thislog->addChild('Em');
				       $cdata->addCData(html_entity_decode($temp['email']));
        	                $cdata = $thislog->addChild('Ct');
				       $cdata->addCData(html_entity_decode($temp['city']));
				$cdata = $thislog->addChild('Subj');
        	                       $cdata->addCData(html_entity_decode($temp['subject']));
				$cdata = $thislog->addChild('Cm');
        	                       $cdata->addCData(html_entity_decode($temp['comentario']));
				$cdata = $thislog->addChild('captcha');
				       $cdata->addCData($captcha);
				$cdata = $thislog->addChild('ip_address');
				$ip = getenv("REMOTE_ADDR");
				       $cdata->addCData(htmlentities($ip));
				$cdata = $thislog->addChild('answ');
				       $cdata->addCData($answ);
				$cdata = $thislog->addChild('moder');
				       $cdata->addCData($moder);
	
				foreach ( $temp as $key => $value ) {
					if (substr($key, 0, 2) != 'q_') {
						$body .= ucfirst($key) .": ". $value ."<br />";
					}
				}
				
				XMLsave($xml, $log_file);

                        //save data en log for last recents comments  
			if ( ! file_exists($log_path.'/pc_lastcom.xml') ) {
               			$xml = new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><channel></channel>');
			} else  {
				$xmldata = file_get_contents($log_path.'/pc_lastcom.xml');
		       		$xml = new SimpleXMLExtended($xmldata);
                        }                            
				$thislog = $xml->addChild('entry');   
 				$cdata = $thislog->addChild('filelog');	
				       $cdata->addCData($log_file_red);
				$thislog->addChild('dateseg', $dateseg);
                        
				XMLsave($xml, $log_path.'/pc_lastcom.xml');


                       //send notication by email
                                if ($sendphpmail == 'st') {
 			            $result = mail($EMAIL,$i18n['pc_FORM_SUB'],$body,$headers);
                        	} else if ($sendphpmail == 'mailer') {
                                  if (is_dir('../PHPMailer_v5.1') and file_exists('../PHPMailer_v5.1/class.phpmailer.php')){
				      require('../PHPMailer_v5.1/class.phpmailer.php');   
     				      $message = new PHPMailer(true); // the true param means it will throw exceptions on errors, which we need to catch
                                      $message->CharSet = "utf-8"; 
                                      $message->SMTPDebug = false;    // enables SMTP debug information (for testing)
                                                                   // false = disabled debug
                                                                   // 1 = errors and messages
                                                                   // 2 = messages only

              			      $message->IsSMTP();            // telling the class to use SMTP
                                      $message->SMTPAuth = true;     // enable SMTP authentication
   
                           /*        //GMAIL Configuration
        	     	       	      $message->SMTPSecure = "ssl";            // sets the prefix to the servier
        		   	      $message->Host       = "smtp.gmail.com"; // sets GMAIL as the SMTP se
        		   	      $message->Port       = 465;              // set the SMTP port for the GMAIL server
        		   	      $message->Username   = "youuser@gmail.com"; // GMAIL user account: youuser@gmail.com
        			      $message->Password   = "youpass";         // GMAIL passwordrver 
                                      $message->From   = "youuser@gmail.com";       // you GMAIL email 
                         */          //end GMAIL Configuration

                                   //ONO configuration     
                          /*          $message->SMTPSecure = "";                  // sets the prefix to the servier
        		   	      $message->Host       = "smtp.ono.com";       // sets ONO as the SMTP server
        			      $message->Port       = 25;                   // set the SMTP port for the ONO server
        			      $message->Username   = "username";               // ONO username 
        			      $message->Password   = "pass";            // ONO password
                                      $message->From   = "user@ono.com";           // you ono email 
                          */       //end ONO Configuration

                                   //HOTMAIL configuration     
        			      $message->SMTPSecure = "tls";                // sets the prefix to the servier
        			      $message->Host       = "smtp.live.com";      // sets hotmail as the SMTP server
        			      $message->Port       = 587;                  // set the SMTP port for hotmail server
        			      $message->Username   = "youruser@hotmail.com";  // hotmail user account
        			      $message->Password   = "yourpass";               // hotmail password
                                      $message->From   = "youremail@hotmail.com";      // you hotmail email 
                                   //end HOTMAIL Configuration

        			      $message->AddAddress($EMAIL, '');  //Recipient's address set 
        			      $message->Subject = $tema;
                                      $message->FromName   = $from;
        			      $message->MsgHTML("$body");
			              $result=$message->Send();
                                   } else {
                                      echo strtoupper($tr_cont['errphphmail']).'<br />';
                                   }
			        } else if ($sendphpmail== 'N') {
                                      $result = 1;
                                }
			//Send email
                        $msgshw = '';
			if ($result=='1') {
				   $msgshw = $i18n['MSG_pcSUC'].'<br /><br />';
			} else {
			/*	echo '<font color="red">*** '.strtoupper(utf8_encode($tr_cont['MSG_pcERR'])).'. ***</font>'; */
			}
			if ($moder == 'N'){
				$seg = 6;	
                                $msgshw = $msgshw.'<b>'.$i18n['nm_modcom'].' '.$i18n['nm_admin'].'</b><br /><br />';		
			} else {
				$seg = 2;
			}
		} else {  //end if err=''
                            $miarr = '';
                            $miarr = serialize($temp);
                            $miarr = urlencode($miarr);
                            if (strpos($MIURL, '?')){
                                $miarr = '&amp;miarr='.$miarr;
                            } else {
                                $miarr = '?miarr='.$miarr;
                            } 
                          //If there is some error.
                             $seg= 4;
			     if (trim($err) !=''){   
			       	$msgshw = '<div id="msgerr">*** '.strtoupper($err).'. ***<br />'.strtoupper($i18n['Cap']).': '.$pot.'<br / >'.strtoupper($i18n['Code']).': '.$_POST['guest']['pot'].'</div><br />';
			     }
		        else {
			     	$msgshw = '<div id="msgerr">*** '.strtoupper($i18n['Co']).' ***</div><br />';
			    }
		}
	} //finish guest-submit
        

  }   //FINISH GUEST


  echo '<html>';
  echo '<head>';
  echo '<meta http-equiv="Refresh" content="'.$seg.';url=http://'.$server_name.$MIURL.$miarr.'">';
  echo '</head>';
  echo '<body>';
  echo '<div style="padding: 20px; border: 4px double; margin: 20%;">';
  echo $msgshw;
  echo $i18n['redir'].$seg.$i18n['redir1'].$i18n['BACK'].'.<br />';
  echo '<a href="http://'.$server_name.$MIURL.$miarr.'">'.$i18n['BACK'].'</a>';
  echo '</div>';
  echo '</body>';
  echo '</html>';
?>
